Package org.apache.lucene.backward_codecs.lucene90

# Class Lucene90HnswVectorsFormat

java.lang.Object
org.apache.lucene.codecs.KnnVectorsFormat
org.apache.lucene.backward_codecs.lucene90.Lucene90HnswVectorsFormat

All Implemented Interfaces:
  `NamedSPILoader.NamedSPI`

public class Lucene90HnswVectorsFormat extends KnnVectorsFormat
Lucene 9.0 vector format, which encodes numeric vector values and an optional associated graph connecting the documents having values. The graph is used to power HNSW search. The format consists of three files:

## .vec (vector data) file

This file stores all the floating-point vector data ordered by field, document ordinal, and vector dimension. The floats are stored in little-endian byte order.

## .vex (vector index) file

Stores graphs connecting the documents for each field. For each document having a vector for a given field, this is stored as:

- [int32] the number of neighbor nodes
- array[vint] the neighbor ordinals, delta-encoded (initially subtracting -1)

## .vem (vector metadata) file

For each field:

- [int32] field number
- [int32] vector similarity function ordinal
- [vlong] offset to this field's vectors in the .vec file
- [vlong] length of this field's vectors, in bytes
- [vlong] offset to this field's index in the .vex file
- [vlong] length of this field's index data, in bytes
- [int] dimension of this field's vectors
- [int] the number of documents having values for this field
- array[vint] the docids of documents having vectors, in order
- array[vlong] for each document having a vector, the offset (delta-encoded relative to the previous document) of its entry in the .vex file

WARNING: This API is experimental and might change in incompatible ways in the next release.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`DEFAULT_BEAM_WIDTH`
Default number of the size of the queue maintained while searching and the number of random entry points to sample during a graph construction.
`static final int`
`DEFAULT_MAX_CONN`
Default number of maximum connections per node

### Fields inherited from class org.apache.lucene.codecs.KnnVectorsFormat

`DEFAULT_MAX_DIMENSIONS, EMPTY`

## Constructor Summary

Constructors
Constructor
Description
`Lucene90HnswVectorsFormat()`
A constructor for vectors format with default parameters
`Lucene90HnswVectorsFormat(int maxConn, int beamWidth)`
A constructor for vectors format

## Method Summary

Modifier and Type
Method
Description
`KnnVectorsReader`
`fieldsReader(SegmentReadState state)`
`KnnVectorsWriter`
`fieldsWriter(SegmentWriteState state)`
`final int`
`getMaxDimensions(String fieldName)`
`String`
`toString()`

### Methods inherited from class org.apache.lucene.codecs.KnnVectorsFormat

`availableKnnVectorsFormats, forName, getName, reloadKnnVectorsFormat`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### DEFAULT_MAX_CONN

public static final int DEFAULT_MAX_CONN
Default number of maximum connections per node

See Also:
  - Constant Field Values

### DEFAULT_BEAM_WIDTH

public static final int DEFAULT_BEAM_WIDTH
Default number of the size of the queue maintained while searching and the number of random entry points to sample during a graph construction.

See Also:
  - Constant Field Values

## Constructor Details

### Lucene90HnswVectorsFormat

public Lucene90HnswVectorsFormat()
A constructor for vectors format with default parameters

### Lucene90HnswVectorsFormat

public Lucene90HnswVectorsFormat(int maxConn, int beamWidth)
A constructor for vectors format

## Method Details

### fieldsWriter

public KnnVectorsWriter fieldsWriter(SegmentWriteState state) throws IOException

Specified by:
  `fieldsWriter` in class `KnnVectorsFormat`
Throws:
  `IOException`

### fieldsReader

public KnnVectorsReader fieldsReader(SegmentReadState state) throws IOException

Specified by:
  `fieldsReader` in class `KnnVectorsFormat`
Throws:
  `IOException`

### getMaxDimensions

public final int getMaxDimensions(String fieldName)

Specified by:
  `getMaxDimensions` in class `KnnVectorsFormat`

### toString

public String toString()

Overrides:
  `toString` in class `Object`